#!/usr/bin/env perl

use RRD::Simple();

die "Usage: file.rrd ds_name GAUGE|DERIVE\n" unless $#ARGV == 3-1;

die "File $ARGV[0] doesn't exist\n" unless -e $ARGV[0];
die "Invalid ds type $ARGV[2]\n" unless $ARGV[2] == "GAUGE" or $ARGV[2] == "DERIVE";

my $rrd = RRD::Simple->new();
$rrd->add_source($ARGV[0], $ARGV[1] => $ARGV[2]);

`rrdtool dump "$ARGV[0]" "$ARGV[0].xml"`;

open(f, "< $ARGV[0].xml") or die("Can't reopen rrd");
open(o, "> $ARGV[0].tmp") or die("Can't open temp rrd");

while (<f>) {
    s|<v> NaN </v></row>|<v> 0 </v></row>|;
    print o $_;
}

close f;
close o;

`rrdtool restore -f "$ARGV[0].tmp"  "$ARGV[0]"`;
