#!/bin/bash

rrdtool update load.rrd N:U:U:U:U:U:U:U:U:U:U

while [ 1 ]; do
    MEMLINE="$(free -b | head -n 2 | tail -n 1)"
    TOTAL=$(echo "$MEMLINE" | awk '{print $2}')
    MEMUSED=$(echo "$MEMLINE" | awk '{print $3}')
    CACHED=$(echo "$MEMLINE" | awk '{print $7}')
    SWAPPED=$(free -b | tail -n 1 | awk '{print $3}')
    LOAD=$(uptime | sed -e 's/.*: //' | sed -e 's/,//g' | awk '{print $2}')
    RUBYUSED=$(ps auxw | grep ruby | grep -v grep | awk '{print $6}' | awk '{n=n+$1} END {print n * 1024}')
    THINUSED=$(ps auxw | grep thin | grep -v grep |awk '{print $6}' | awk '{n=n+$1} END {print n * 1024}')
    MONGRELUSED=$(ps auxw | grep mongrel | grep -v grep | awk '{print $6}' | awk '{n=n+$1} END {print n * 1024}')
    NGINXUSED=$(ps auxw | grep nginx | grep -v grep | awk '{print $6}' | awk '{n=n+$1} END {print n * 1024}')
    MYSQLUSED=$(ps auxw | grep mysql | grep -v grep | awk '{print $6}' | awk '{n=n+$1} END {print n * 1024}')
    POSTGRESUSED=$(ps auxw | grep postgres | grep -v grep | awk '{print $6}' | awk '{n=n+$1} END {print n * 1024}')

    LINE="N:$MEMUSED:$CACHED:$SWAPPED:$LOAD:$RUBYUSED:$THINUSED:$MONGRELUSED:$NGINXUSED:$MYSQLUSED:$POSTGRESUSED"
    #echo "$LINE"
    rrdtool update load.rrd "$LINE"
    rrdtool graph load-day.png -l 0 -u 1 --start -86400 \
            -w 600 -h 170 -E \
            DEF:load=load.rrd:load:AVERAGE \
            DEF:yesterdayload=load.rrd:load:AVERAGE:end=now-1d:start=end-1d \
            SHIFT:yesterdayload:86400 \
            TEXTALIGN:left \
            LINE2:load#ff0000:"Today's Load" \
            VDEF:vload=load,AVERAGE \
            GPRINT:vload:"%6.2lf avg               " \
            LINE1:yesterdayload#99cc99:"Yesterday's Load"
    rrdtool graph ram-day.png -l 0 --start -86400 \
            -w 600 -h 170 -E \
            DEF:memused=load.rrd:memused:AVERAGE \
            DEF:swapused=load.rrd:swapused:AVERAGE \
            DEF:cached=load.rrd:cached:AVERAGE \
            DEF:thinused=load.rrd:thinused:AVERAGE \
            DEF:mongrelused=load.rrd:mongrelused:AVERAGE \
            DEF:nginxused=load.rrd:nginxused:AVERAGE \
            DEF:mysqlused=load.rrd:mysqlused:AVERAGE \
            DEF:postgresused=load.rrd:postgresused:AVERAGE \
            CDEF:realused=memused,cached,- \
            CDEF:realnonruby=memused,cached,-,thinused,-,mongrelused,-,nginxused,-,mysqlused,-,postgresused,- \
            TEXTALIGN:left \
            AREA:thinused#333333:"Thins" \
            AREA:mongrelused#669966:"Mongrels":STACK \
            AREA:nginxused#e8ac44:"Nginx":STACK \
            AREA:mysqlused#e844e2:"Mysql":STACK \
            AREA:postgresused#7e2e8c:"Postgres":STACK \
            AREA:realnonruby#6699cc:"Other Real Mem":STACK \
            AREA:cached#99cc99:"Cached":STACK \
            AREA:swapused#ff6666:"Swap Used":STACK \
            LINE2:memused#66cc99 \
            HRULE:$TOTAL#cc0000:"Physical RAM"

    perl -e 'sleep 300 - time % 300'
done
